#--- 1d1f1v ---#
function flux_kcu!(
    fw::T1,
    ff::T2,
    fL::T3,
    fR::T3,
    u::T4,
    ω::T4,
    nu,
    inK,
    γ,
    visRef,
    visIdx,
    Pr,
    dt,
    sfL = zeros(eltype(fL), axes(fL))::T3,
    sfR = zeros(eltype(fL), axes(fL))::T3,
) where {
    T1<:AbstractArray{<:AbstractFloat,1},
    T2<:AbstractArray{<:AbstractFloat,1},
    T3<:AbstractArray{<:AbstractFloat,1},
    T4<:AbstractArray{<:AbstractFloat,1},
}
    cd(@__DIR__)
    ccall(
        (:__kinetic_MOD_flux_kcu_1f1v, "fortran/kitmod.so"),
        Nothing,
        (
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Int}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
        ),
        fw,
        ff,
        fL,
        fR,
        u,
        ω,
        nu,
        inK,
        γ,
        visRef,
        visIdx,
        Pr,
        dt,
        sfL,
        sfR,
    )
end

#--- 1d2f1v ---#
function flux_kcu!(
    fw::T1,
    fh::T2,
    fb::T2,
    hL::T3,
    bL::T3,
    hR::T3,
    bR::T3,
    u::T4,
    ω::T4,
    nu,
    inK,
    γ,
    visRef,
    visIdx,
    Pr,
    dt,
    shL = zeros(eltype(hL), axes(hL))::T3,
    sbL = zeros(eltype(bL), axes(bL))::T3,
    shR = zeros(eltype(hR), axes(hR))::T3,
    sbR = zeros(eltype(bR), axes(bR))::T3,
) where {
    T1<:AbstractArray{<:AbstractFloat,1},
    T2<:AbstractArray{<:AbstractFloat,1},
    T3<:AbstractArray{<:AbstractFloat,1},
    T4<:AbstractArray{<:AbstractFloat,1},
}
    cd(@__DIR__)
    ccall(
        (:__kinetic_MOD_flux_kcu_2f1v, "fortran/kitmod.so"),
        Nothing,
        (
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64},
            Ref{Int}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64},
        ),
        fw,
        fh,
        fb,
        hL,
        bL,
        hR,
        bR,
        u,
        ω,
        nu,
        inK,
        γ,
        visRef,
        visIdx,
        Pr,
        dt,
        shL,
        sbL,
        shR,
        sbR,
    )
end