#--- 1d1f1v ---#
function flux_ugks!(
    fw::T1,
    ff::T2,
    wL::T3,
    fL::T4,
    wR::T3,
    fR::T4,
    u::T5,
    ω::T5,
    nu,
    inK,
    γ,
    visRef,
    visIdx,
    Pr,
    dt,
    dxL,
    dxR,
    sfL = zeros(eltype(fL), axes(fL))::T4,
    sfR = zeros(eltype(fR), axes(fR))::T4,
) where {
    T1<:AbstractArray{<:AbstractFloat,1},
    T2<:AbstractArray{<:AbstractFloat,1},
    T3<:AbstractArray{<:AbstractFloat,1},
    T4<:AbstractArray{<:AbstractFloat,1},
    T5<:AbstractArray{<:AbstractFloat,1},
}
    cd(@__DIR__)
    ccall(
        (:__kinetic_MOD_flux_ugks_1f1v, "fortran/kitmod.so"),
        Nothing,
        (
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64},
            Ref{Int}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
        ),
        fw,
        ff,
        wL,
        fL,
        wR,
        fR,
        u,
        ω,
        nu,
        inK,
        γ,
        visRef,
        visIdx,
        Pr,
        dt,
        dxL,
        dxR,
        sfL,
        sfR,
    )
end

#--- 1d2f1v ---#
function flux_ugks!(
    fw::T1,
    fh::T2,
    fb::T2,
    wL::T3,
    hL::T4,
    bL::T4,
    wR::T3,
    hR::T4,
    bR::T4,
    u::T5,
    ω::T5,
    nu,
    inK,
    γ,
    visRef,
    visIdx,
    Pr,
    dt,
    dxL,
    dxR,
    shL = zeros(eltype(hL), axes(hL))::T4,
    sbL = zeros(eltype(bL), axes(bL))::T4,
    shR = zeros(eltype(hR), axes(hR))::T4,
    sbR = zeros(eltype(bR), axes(bR))::T4,
) where {
    T1<:AbstractArray{<:AbstractFloat,1},
    T2<:AbstractArray{<:AbstractFloat,1},
    T3<:AbstractArray{<:AbstractFloat,1},
    T4<:AbstractArray{<:AbstractFloat,1},
    T5<:AbstractArray{<:AbstractFloat,1},
}
    cd(@__DIR__)
    ccall(
        (:__kinetic_MOD_flux_ugks_2f1v, "fortran/kitmod.so"),
        Nothing,
        (
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64},
            Ref{Int}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64}, 
            Ref{Float64},
            Ref{Float64}, 
            Ref{Float64},
        ),
        fw,
        fh,
        fb,
        wL,
        hL,
        bL,
        wR,
        hR,
        bR,
        u,
        ω,
        nu,
        inK,
        γ,
        visRef,
        visIdx,
        Pr,
        dt,
        dxL,
        dxR,
        shL,
        sbL,
        shR,
        sbR,
    )
end